include("Source/md5.js");

/* 
 * define value, shouldn't be changed runtime 
 */
var IP_ERROR = 0;
var PASSWORD_ERROR = 1;
var CHANGE_IP_IN_ROUTER_TRY_TIMES = 2;


/* flag for ensuring that only one session is waiting for response */
var wait_last_session_flag = false;

/* flag for timeout-error while changing router ip */
var max_timeout_sec = 0;

function set_wait_last_session_flag(value){
	wait_last_session_flag = value;
}

function get_wait_last_session_flag(){
	return wait_last_session_flag;
}

function clearAllimage()
{	
	    clickImage.src="";
	    modelImage.src="";
	    bgImage_line1.src="";
	    bgImage_line2.src="";
	    bgImage_line3.src="";
	    bgImage_line4.src="";
  		wan_data_1.src="";
      wan_data_2.src="";
  		wan_data_3.src="";
  		lan_data_1.src="";
  		lan_data_2.src="";
  		lan_data_3.src="";
  		wlan2_data_1.src="";
  		wlan2_data_2.src="";
  		wlan2_data_3.src="";
  		wlan5_data_1.src="";
  		wlan5_data_2.src="";
  		wlan5_data_3.src="";
  	  for_unit1.data="";
	    for_unit2.data="";
	    for_unit3.data="";
	    for_unit4.data="";
}

function login_stage2_done(url){
//	print("---------- Login stage 2 ----------");
	
	var xml, result;
	var urlData = url.responseData;
	
	if(!urlData){
		/* signal the application that we can not contact the router under the provided ip address */
		print("Could not contact router in login stage2");
		print("---------- 1----------");	
		clearAllimage(); 	
		showImage.src="Resources/UI/IP_error.png";  
		clearAllimage();  
		set_login_flag(false);
		login_fail(IP_ERROR);
		wait_last_session_flag = false;
		return;
	}
	
	xml = XMLDOM.parse(urlData);
	result = xml.evaluate("string (/login)");
	if(result == "error"){
		print("stage2 login failed");
		clearAllimage(); 
		showImage.src="Resources/UI/password_error.png";  
		clearAllimage(); 
		/* signal user to review their password */
		set_login_flag(false);
		login_fail(PASSWORD_ERROR);
		wait_last_session_flag = false;
		max_timeout_sec = 0;
		
		/* close login-timer while password error */
		loginTimer.ticking = false;
		
		return;
	}
	
	if(result == "timeout"){
		print("Could not contact router in login stage2");
		print("---------- 2----------");
		clearAllimage(); 
		showImage.src="Resources/UI/IP_error.png";   
		clearAllimage(); 
		set_login_flag(false);
		login_fail(IP_ERROR);
		wait_last_session_flag = false;
		return;
	}

	print("Login successful");
	
	/* clear old login-error message */
	if(get_ping_success_latest_flag() == false){		
		clearAllData(true);
	}
	
	/* avoid to set login_flag by other dead-sessions before while ip was changed */
	set_ping_success_latest_flag(true);	
	set_login_flag(true);
	
	/* allow that the session can be established while login was success */
	wait_last_session_flag = false;
	max_timeout_sec = 0;
	
	return;
}

function login_stage1_done(url){
	print("---------- Login stage 1 ----------");
	print("ping_success_latest_flag===="+ping_success_latest_flag);
	print("wait_last_session_flag==="+wait_last_session_flag);
		/* signal the application that we can not contact the router under the provided ip address */
	if(!url.responseData){	
		if(get_ping_success_latest_flag() == false && wait_last_session_flag){	
			print("---------- 3 ----------");	
			clearAllimage();
			showImage.src="Resources/UI/IP_error.png"; 
			clearAllimage();   
			set_login_flag(false);
			login_fail(IP_ERROR);
		}	
		print("Could not contact router in login stage1");		
		    wait_last_session_flag = false;
		//   set_ping_success_latest_flag(false);	//YCH add
		return;
	}
	
	/* extract the salt from the page */	
	var match = /salt\s=\s"(.*)"/.exec(url.result);	
	if(match){
		salt=match[1];
	}else{
		salt="";
	}	
  
	/* get the admin password from the widget preference */	
	var password = preferences.loginPassword.value;
	//print("Password: " + password);
	/* Pad the password to 16 chars. */
	for (var i = password.length; i < 16; i++) {
		password += String.fromCharCode(1);
	}
  
	/* Append the password to the salt and pad the result to 63 bytes. */
	var input = salt + password;
	for (var i = input.length; i < 63; i++) {
		input += String.fromCharCode(1);
	}
  
	/* Append a 'U' for user login, or a '\x01' for admin login. */
	//input += String.fromCharCode(1);
	input += '\x01';
	/* MD5 hash of the salt. */
	var hash = hex_md5(input);
	/* Append the MD5 hash to the salt. */
	var login_hash = salt.concat(hash);
  
	/* Send the login hash to the server. */
	url.location = "http://" + preferences.loginIP.value + "/post_login.xml?hash=" + login_hash;
	//print(login_hash);
	url.fetchAsync(login_stage2_done);
	return;
}

function login(){	
	   print("---------- login----------");  
	/* check if ip-error while user change ip in router-UI setting page */
	if(max_timeout_sec == CHANGE_IP_IN_ROUTER_TRY_TIMES){
		print("max timout was detected, classify this error to ip-error");
		print("---------- 4----------");	
		 clearAllimage(); 	 
		 showImage.src="Resources/UI/IP_error.png";  
		 clearAllimage(); 
		 set_login_flag(false);
		 login_fail(IP_ERROR);				
	}
	/* 
	 * login to router every one session, need to ipconfig release/renew after 
	 * router change the lan ip address.(the old session will keep the error ip)
	 */

	if(wait_last_session_flag == false){
	  print("---------- Logging in : "+preferences.loginIP.value+" ----------");	
	  var url = new URL();
	  /* The login page contains the salt that is needed to compose the login hash */
	  url.timeout = 1;
	  url.location = "http://" + preferences.loginIP.value;
	  wait_last_session_flag = true;
	  url.fetchAsync(login_stage1_done);	 
	  url=null; 
	/* "session busy" maybe express that the widget can't access the router-ip */  
	}else{	
		print("session is busy .......");
		if(max_timeout_sec <= CHANGE_IP_IN_ROUTER_TRY_TIMES){
		print("max timeout count(max=30): "+(max_timeout_sec+1)*10);
		max_timeout_sec ++;
		}	
	}  
}
